// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: settlement.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace Settlement {

  /// <summary>Holder for reflection information generated from settlement.proto</summary>
  public static partial class SettlementReflection {

    #region Descriptor
    /// <summary>File descriptor for settlement.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static SettlementReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "ChBzZXR0bGVtZW50LnByb3RvEgpzZXR0bGVtZW50Gh9nb29nbGUvcHJvdG9i",
            "dWYvdGltZXN0YW1wLnByb3RvGgxjb21tb24ucHJvdG8aD3Jlc291cmNlcy5w",
            "cm90byKfAgoKU2V0dGxlbWVudBIMCgRuYW1lGAEgASgJEgoKAmlkGAIgASgD",
            "EhAKCHBsYXllcklEGAMgASgDEiEKA3BvcxgEIAEoCzIULnNldHRsZW1lbnQu",
            "UG9zaXRpb24SIAoFZGVwb3QYBSABKAsyES5zZXR0bGVtZW50LkRlcG90EicK",
            "CWJ1aWxkaW5ncxgGIAMoCzIULnNldHRsZW1lbnQuQnVpbGRpbmcSLgoKYnVp",
            "bGRRdWV1ZRgHIAMoCzIaLnNldHRsZW1lbnQuQnVpbGRRdWV1ZUl0ZW0SFgoO",
            "YnVpbGRRdWV1ZVNpemUYCCABKAMSLwoLbGFzdF91cGRhdGUYCSABKAsyGi5n",
            "b29nbGUucHJvdG9idWYuVGltZXN0YW1wIoQBCg5CdWlsZFF1ZXVlSXRlbRIS",
            "CgpidWlsZGluZ0lkGAEgASgDEi8KC2J1aWxkX3N0YXJ0GAIgASgLMhouZ29v",
            "Z2xlLnByb3RvYnVmLlRpbWVzdGFtcBItCglidWlsZF9lbmQYAyABKAsyGi5n",
            "b29nbGUucHJvdG9idWYuVGltZXN0YW1wIiAKCFBvc2l0aW9uEgkKAXgYASAB",
            "KAMSCQoBeRgCIAEoAyIzCgVEZXBvdBIqCgVTdG9yZRgBIAMoCzIbLnNldHRs",
            "ZW1lbnQuUmVzb3VyY2VTdG9yYWdlIjoKD1Jlc291cmNlU3RvcmFnZRIQCghj",
            "YXBhY2l0eRgBIAEoAxIVCg1jdXJyZW50U3RvcmVkGAIgASgDIj0KDlNldHRs",
            "ZW1lbnRMaXN0EisKC3NldHRsZW1lbnRzGAEgAygLMhYuc2V0dGxlbWVudC5T",
            "ZXR0bGVtZW50IlQKCEJ1aWxkaW5nEgoKAmlkGAEgASgDEhAKCGJ1aWxkRGVm",
            "GAMgASgJEhYKDmluQ29uc3RydWN0aW9uGAQgASgIEhIKCmhpYmVybmF0ZWQY",
            "BSABKAgiUQoRQnVpbGRCdWlsZGluZ0NhbGwSKgoMc2V0dGxlbWVudElkGAEg",
            "ASgLMhQuY29tbW9uLlNldHRsZW1lbnRJZBIQCghidWlsZERlZhgCIAEoCSJp",
            "ChNVcGdyYWRlQnVpbGRpbmdDYWxsEioKDHNldHRsZW1lbnRJZBgBIAEoCzIU",
            "LmNvbW1vbi5TZXR0bGVtZW50SWQSJgoKYnVpbGRpbmdJZBgCIAEoCzISLmNv",
            "bW1vbi5CdWlsZGluZ0lkMocEChJTZXR0bGVtZW50U2VydmljZXMSQQoNQWRk",
            "U2V0dGxlbWVudBIWLnNldHRsZW1lbnQuU2V0dGxlbWVudBoWLnNldHRsZW1l",
            "bnQuU2V0dGxlbWVudCIAEkUKEUFkZFRlc3RTZXR0bGVtZW50EhYuc2V0dGxl",
            "bWVudC5TZXR0bGVtZW50GhYuc2V0dGxlbWVudC5TZXR0bGVtZW50IgASQwoR",
            "R2V0U2V0dGxlbWVudEJ5SUQSFC5jb21tb24uU2V0dGxlbWVudElkGhYuc2V0",
            "dGxlbWVudC5TZXR0bGVtZW50IgASRgoWR2V0U2V0dGxlbWVudHNCeVVzZXJJ",
            "RBIOLmNvbW1vbi5Vc2VySWQaGi5zZXR0bGVtZW50LlNldHRsZW1lbnRMaXN0",
            "IgASQgoQRGVsZXRlU2V0dGxlbWVudBIULmNvbW1vbi5TZXR0bGVtZW50SWQa",
            "Fi5jb21tb24uUmVzcG9uc2VTdGF0dXMiABJICg1CdWlsZEJ1aWxkaW5nEh0u",
            "c2V0dGxlbWVudC5CdWlsZEJ1aWxkaW5nQ2FsbBoWLmNvbW1vbi5SZXNwb25z",
            "ZVN0YXR1cyIAEkwKD1VwZ3JhZGVCdWlsZGluZxIfLnNldHRsZW1lbnQuVXBn",
            "cmFkZUJ1aWxkaW5nQ2FsbBoWLmNvbW1vbi5SZXNwb25zZVN0YXR1cyIAQjNa",
            "MWdpdGxhYi5jb20vdmFqYXJfbWluaWdhbWUvcHJvdG9fZ28vZ2VuL3NldHRs",
            "ZW1lbnRiBnByb3RvMw=="));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { global::Google.Protobuf.WellKnownTypes.TimestampReflection.Descriptor, global::Common.CommonReflection.Descriptor, global::Resources.ResourcesReflection.Descriptor, },
          new pbr::GeneratedClrTypeInfo(null, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::Settlement.Settlement), global::Settlement.Settlement.Parser, new[]{ "Name", "Id", "PlayerID", "Pos", "Depot", "Buildings", "BuildQueue", "BuildQueueSize", "LastUpdate" }, null, null, null, null),
            new pbr::GeneratedClrTypeInfo(typeof(global::Settlement.BuildQueueItem), global::Settlement.BuildQueueItem.Parser, new[]{ "BuildingId", "BuildStart", "BuildEnd" }, null, null, null, null),
            new pbr::GeneratedClrTypeInfo(typeof(global::Settlement.Position), global::Settlement.Position.Parser, new[]{ "X", "Y" }, null, null, null, null),
            new pbr::GeneratedClrTypeInfo(typeof(global::Settlement.Depot), global::Settlement.Depot.Parser, new[]{ "Store" }, null, null, null, null),
            new pbr::GeneratedClrTypeInfo(typeof(global::Settlement.ResourceStorage), global::Settlement.ResourceStorage.Parser, new[]{ "Capacity", "CurrentStored" }, null, null, null, null),
            new pbr::GeneratedClrTypeInfo(typeof(global::Settlement.SettlementList), global::Settlement.SettlementList.Parser, new[]{ "Settlements" }, null, null, null, null),
            new pbr::GeneratedClrTypeInfo(typeof(global::Settlement.Building), global::Settlement.Building.Parser, new[]{ "Id", "BuildDef", "InConstruction", "Hibernated" }, null, null, null, null),
            new pbr::GeneratedClrTypeInfo(typeof(global::Settlement.BuildBuildingCall), global::Settlement.BuildBuildingCall.Parser, new[]{ "SettlementId", "BuildDef" }, null, null, null, null),
            new pbr::GeneratedClrTypeInfo(typeof(global::Settlement.UpgradeBuildingCall), global::Settlement.UpgradeBuildingCall.Parser, new[]{ "SettlementId", "BuildingId" }, null, null, null, null)
          }));
    }
    #endregion

  }
  #region Messages
  public sealed partial class Settlement : pb::IMessage<Settlement>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<Settlement> _parser = new pb::MessageParser<Settlement>(() => new Settlement());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pb::MessageParser<Settlement> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Settlement.SettlementReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Settlement() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Settlement(Settlement other) : this() {
      name_ = other.name_;
      id_ = other.id_;
      playerID_ = other.playerID_;
      pos_ = other.pos_ != null ? other.pos_.Clone() : null;
      depot_ = other.depot_ != null ? other.depot_.Clone() : null;
      buildings_ = other.buildings_.Clone();
      buildQueue_ = other.buildQueue_.Clone();
      buildQueueSize_ = other.buildQueueSize_;
      lastUpdate_ = other.lastUpdate_ != null ? other.lastUpdate_.Clone() : null;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Settlement Clone() {
      return new Settlement(this);
    }

    /// <summary>Field number for the "name" field.</summary>
    public const int NameFieldNumber = 1;
    private string name_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public string Name {
      get { return name_; }
      set {
        name_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "id" field.</summary>
    public const int IdFieldNumber = 2;
    private long id_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public long Id {
      get { return id_; }
      set {
        id_ = value;
      }
    }

    /// <summary>Field number for the "playerID" field.</summary>
    public const int PlayerIDFieldNumber = 3;
    private long playerID_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public long PlayerID {
      get { return playerID_; }
      set {
        playerID_ = value;
      }
    }

    /// <summary>Field number for the "pos" field.</summary>
    public const int PosFieldNumber = 4;
    private global::Settlement.Position pos_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Settlement.Position Pos {
      get { return pos_; }
      set {
        pos_ = value;
      }
    }

    /// <summary>Field number for the "depot" field.</summary>
    public const int DepotFieldNumber = 5;
    private global::Settlement.Depot depot_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Settlement.Depot Depot {
      get { return depot_; }
      set {
        depot_ = value;
      }
    }

    /// <summary>Field number for the "buildings" field.</summary>
    public const int BuildingsFieldNumber = 6;
    private static readonly pb::FieldCodec<global::Settlement.Building> _repeated_buildings_codec
        = pb::FieldCodec.ForMessage(50, global::Settlement.Building.Parser);
    private readonly pbc::RepeatedField<global::Settlement.Building> buildings_ = new pbc::RepeatedField<global::Settlement.Building>();
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public pbc::RepeatedField<global::Settlement.Building> Buildings {
      get { return buildings_; }
    }

    /// <summary>Field number for the "buildQueue" field.</summary>
    public const int BuildQueueFieldNumber = 7;
    private static readonly pb::FieldCodec<global::Settlement.BuildQueueItem> _repeated_buildQueue_codec
        = pb::FieldCodec.ForMessage(58, global::Settlement.BuildQueueItem.Parser);
    private readonly pbc::RepeatedField<global::Settlement.BuildQueueItem> buildQueue_ = new pbc::RepeatedField<global::Settlement.BuildQueueItem>();
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public pbc::RepeatedField<global::Settlement.BuildQueueItem> BuildQueue {
      get { return buildQueue_; }
    }

    /// <summary>Field number for the "buildQueueSize" field.</summary>
    public const int BuildQueueSizeFieldNumber = 8;
    private long buildQueueSize_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public long BuildQueueSize {
      get { return buildQueueSize_; }
      set {
        buildQueueSize_ = value;
      }
    }

    /// <summary>Field number for the "last_update" field.</summary>
    public const int LastUpdateFieldNumber = 9;
    private global::Google.Protobuf.WellKnownTypes.Timestamp lastUpdate_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Google.Protobuf.WellKnownTypes.Timestamp LastUpdate {
      get { return lastUpdate_; }
      set {
        lastUpdate_ = value;
      }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override bool Equals(object other) {
      return Equals(other as Settlement);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Equals(Settlement other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (Name != other.Name) return false;
      if (Id != other.Id) return false;
      if (PlayerID != other.PlayerID) return false;
      if (!object.Equals(Pos, other.Pos)) return false;
      if (!object.Equals(Depot, other.Depot)) return false;
      if(!buildings_.Equals(other.buildings_)) return false;
      if(!buildQueue_.Equals(other.buildQueue_)) return false;
      if (BuildQueueSize != other.BuildQueueSize) return false;
      if (!object.Equals(LastUpdate, other.LastUpdate)) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override int GetHashCode() {
      int hash = 1;
      if (Name.Length != 0) hash ^= Name.GetHashCode();
      if (Id != 0L) hash ^= Id.GetHashCode();
      if (PlayerID != 0L) hash ^= PlayerID.GetHashCode();
      if (pos_ != null) hash ^= Pos.GetHashCode();
      if (depot_ != null) hash ^= Depot.GetHashCode();
      hash ^= buildings_.GetHashCode();
      hash ^= buildQueue_.GetHashCode();
      if (BuildQueueSize != 0L) hash ^= BuildQueueSize.GetHashCode();
      if (lastUpdate_ != null) hash ^= LastUpdate.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (Name.Length != 0) {
        output.WriteRawTag(10);
        output.WriteString(Name);
      }
      if (Id != 0L) {
        output.WriteRawTag(16);
        output.WriteInt64(Id);
      }
      if (PlayerID != 0L) {
        output.WriteRawTag(24);
        output.WriteInt64(PlayerID);
      }
      if (pos_ != null) {
        output.WriteRawTag(34);
        output.WriteMessage(Pos);
      }
      if (depot_ != null) {
        output.WriteRawTag(42);
        output.WriteMessage(Depot);
      }
      buildings_.WriteTo(output, _repeated_buildings_codec);
      buildQueue_.WriteTo(output, _repeated_buildQueue_codec);
      if (BuildQueueSize != 0L) {
        output.WriteRawTag(64);
        output.WriteInt64(BuildQueueSize);
      }
      if (lastUpdate_ != null) {
        output.WriteRawTag(74);
        output.WriteMessage(LastUpdate);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (Name.Length != 0) {
        output.WriteRawTag(10);
        output.WriteString(Name);
      }
      if (Id != 0L) {
        output.WriteRawTag(16);
        output.WriteInt64(Id);
      }
      if (PlayerID != 0L) {
        output.WriteRawTag(24);
        output.WriteInt64(PlayerID);
      }
      if (pos_ != null) {
        output.WriteRawTag(34);
        output.WriteMessage(Pos);
      }
      if (depot_ != null) {
        output.WriteRawTag(42);
        output.WriteMessage(Depot);
      }
      buildings_.WriteTo(ref output, _repeated_buildings_codec);
      buildQueue_.WriteTo(ref output, _repeated_buildQueue_codec);
      if (BuildQueueSize != 0L) {
        output.WriteRawTag(64);
        output.WriteInt64(BuildQueueSize);
      }
      if (lastUpdate_ != null) {
        output.WriteRawTag(74);
        output.WriteMessage(LastUpdate);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public int CalculateSize() {
      int size = 0;
      if (Name.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Name);
      }
      if (Id != 0L) {
        size += 1 + pb::CodedOutputStream.ComputeInt64Size(Id);
      }
      if (PlayerID != 0L) {
        size += 1 + pb::CodedOutputStream.ComputeInt64Size(PlayerID);
      }
      if (pos_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(Pos);
      }
      if (depot_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(Depot);
      }
      size += buildings_.CalculateSize(_repeated_buildings_codec);
      size += buildQueue_.CalculateSize(_repeated_buildQueue_codec);
      if (BuildQueueSize != 0L) {
        size += 1 + pb::CodedOutputStream.ComputeInt64Size(BuildQueueSize);
      }
      if (lastUpdate_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(LastUpdate);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(Settlement other) {
      if (other == null) {
        return;
      }
      if (other.Name.Length != 0) {
        Name = other.Name;
      }
      if (other.Id != 0L) {
        Id = other.Id;
      }
      if (other.PlayerID != 0L) {
        PlayerID = other.PlayerID;
      }
      if (other.pos_ != null) {
        if (pos_ == null) {
          Pos = new global::Settlement.Position();
        }
        Pos.MergeFrom(other.Pos);
      }
      if (other.depot_ != null) {
        if (depot_ == null) {
          Depot = new global::Settlement.Depot();
        }
        Depot.MergeFrom(other.Depot);
      }
      buildings_.Add(other.buildings_);
      buildQueue_.Add(other.buildQueue_);
      if (other.BuildQueueSize != 0L) {
        BuildQueueSize = other.BuildQueueSize;
      }
      if (other.lastUpdate_ != null) {
        if (lastUpdate_ == null) {
          LastUpdate = new global::Google.Protobuf.WellKnownTypes.Timestamp();
        }
        LastUpdate.MergeFrom(other.LastUpdate);
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            Name = input.ReadString();
            break;
          }
          case 16: {
            Id = input.ReadInt64();
            break;
          }
          case 24: {
            PlayerID = input.ReadInt64();
            break;
          }
          case 34: {
            if (pos_ == null) {
              Pos = new global::Settlement.Position();
            }
            input.ReadMessage(Pos);
            break;
          }
          case 42: {
            if (depot_ == null) {
              Depot = new global::Settlement.Depot();
            }
            input.ReadMessage(Depot);
            break;
          }
          case 50: {
            buildings_.AddEntriesFrom(input, _repeated_buildings_codec);
            break;
          }
          case 58: {
            buildQueue_.AddEntriesFrom(input, _repeated_buildQueue_codec);
            break;
          }
          case 64: {
            BuildQueueSize = input.ReadInt64();
            break;
          }
          case 74: {
            if (lastUpdate_ == null) {
              LastUpdate = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(LastUpdate);
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            Name = input.ReadString();
            break;
          }
          case 16: {
            Id = input.ReadInt64();
            break;
          }
          case 24: {
            PlayerID = input.ReadInt64();
            break;
          }
          case 34: {
            if (pos_ == null) {
              Pos = new global::Settlement.Position();
            }
            input.ReadMessage(Pos);
            break;
          }
          case 42: {
            if (depot_ == null) {
              Depot = new global::Settlement.Depot();
            }
            input.ReadMessage(Depot);
            break;
          }
          case 50: {
            buildings_.AddEntriesFrom(ref input, _repeated_buildings_codec);
            break;
          }
          case 58: {
            buildQueue_.AddEntriesFrom(ref input, _repeated_buildQueue_codec);
            break;
          }
          case 64: {
            BuildQueueSize = input.ReadInt64();
            break;
          }
          case 74: {
            if (lastUpdate_ == null) {
              LastUpdate = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(LastUpdate);
            break;
          }
        }
      }
    }
    #endif

  }

  public sealed partial class BuildQueueItem : pb::IMessage<BuildQueueItem>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<BuildQueueItem> _parser = new pb::MessageParser<BuildQueueItem>(() => new BuildQueueItem());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pb::MessageParser<BuildQueueItem> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Settlement.SettlementReflection.Descriptor.MessageTypes[1]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public BuildQueueItem() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public BuildQueueItem(BuildQueueItem other) : this() {
      buildingId_ = other.buildingId_;
      buildStart_ = other.buildStart_ != null ? other.buildStart_.Clone() : null;
      buildEnd_ = other.buildEnd_ != null ? other.buildEnd_.Clone() : null;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public BuildQueueItem Clone() {
      return new BuildQueueItem(this);
    }

    /// <summary>Field number for the "buildingId" field.</summary>
    public const int BuildingIdFieldNumber = 1;
    private long buildingId_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public long BuildingId {
      get { return buildingId_; }
      set {
        buildingId_ = value;
      }
    }

    /// <summary>Field number for the "build_start" field.</summary>
    public const int BuildStartFieldNumber = 2;
    private global::Google.Protobuf.WellKnownTypes.Timestamp buildStart_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Google.Protobuf.WellKnownTypes.Timestamp BuildStart {
      get { return buildStart_; }
      set {
        buildStart_ = value;
      }
    }

    /// <summary>Field number for the "build_end" field.</summary>
    public const int BuildEndFieldNumber = 3;
    private global::Google.Protobuf.WellKnownTypes.Timestamp buildEnd_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Google.Protobuf.WellKnownTypes.Timestamp BuildEnd {
      get { return buildEnd_; }
      set {
        buildEnd_ = value;
      }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override bool Equals(object other) {
      return Equals(other as BuildQueueItem);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Equals(BuildQueueItem other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (BuildingId != other.BuildingId) return false;
      if (!object.Equals(BuildStart, other.BuildStart)) return false;
      if (!object.Equals(BuildEnd, other.BuildEnd)) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override int GetHashCode() {
      int hash = 1;
      if (BuildingId != 0L) hash ^= BuildingId.GetHashCode();
      if (buildStart_ != null) hash ^= BuildStart.GetHashCode();
      if (buildEnd_ != null) hash ^= BuildEnd.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (BuildingId != 0L) {
        output.WriteRawTag(8);
        output.WriteInt64(BuildingId);
      }
      if (buildStart_ != null) {
        output.WriteRawTag(18);
        output.WriteMessage(BuildStart);
      }
      if (buildEnd_ != null) {
        output.WriteRawTag(26);
        output.WriteMessage(BuildEnd);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (BuildingId != 0L) {
        output.WriteRawTag(8);
        output.WriteInt64(BuildingId);
      }
      if (buildStart_ != null) {
        output.WriteRawTag(18);
        output.WriteMessage(BuildStart);
      }
      if (buildEnd_ != null) {
        output.WriteRawTag(26);
        output.WriteMessage(BuildEnd);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public int CalculateSize() {
      int size = 0;
      if (BuildingId != 0L) {
        size += 1 + pb::CodedOutputStream.ComputeInt64Size(BuildingId);
      }
      if (buildStart_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(BuildStart);
      }
      if (buildEnd_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(BuildEnd);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(BuildQueueItem other) {
      if (other == null) {
        return;
      }
      if (other.BuildingId != 0L) {
        BuildingId = other.BuildingId;
      }
      if (other.buildStart_ != null) {
        if (buildStart_ == null) {
          BuildStart = new global::Google.Protobuf.WellKnownTypes.Timestamp();
        }
        BuildStart.MergeFrom(other.BuildStart);
      }
      if (other.buildEnd_ != null) {
        if (buildEnd_ == null) {
          BuildEnd = new global::Google.Protobuf.WellKnownTypes.Timestamp();
        }
        BuildEnd.MergeFrom(other.BuildEnd);
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 8: {
            BuildingId = input.ReadInt64();
            break;
          }
          case 18: {
            if (buildStart_ == null) {
              BuildStart = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(BuildStart);
            break;
          }
          case 26: {
            if (buildEnd_ == null) {
              BuildEnd = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(BuildEnd);
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 8: {
            BuildingId = input.ReadInt64();
            break;
          }
          case 18: {
            if (buildStart_ == null) {
              BuildStart = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(BuildStart);
            break;
          }
          case 26: {
            if (buildEnd_ == null) {
              BuildEnd = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(BuildEnd);
            break;
          }
        }
      }
    }
    #endif

  }

  public sealed partial class Position : pb::IMessage<Position>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<Position> _parser = new pb::MessageParser<Position>(() => new Position());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pb::MessageParser<Position> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Settlement.SettlementReflection.Descriptor.MessageTypes[2]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Position() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Position(Position other) : this() {
      x_ = other.x_;
      y_ = other.y_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Position Clone() {
      return new Position(this);
    }

    /// <summary>Field number for the "x" field.</summary>
    public const int XFieldNumber = 1;
    private long x_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public long X {
      get { return x_; }
      set {
        x_ = value;
      }
    }

    /// <summary>Field number for the "y" field.</summary>
    public const int YFieldNumber = 2;
    private long y_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public long Y {
      get { return y_; }
      set {
        y_ = value;
      }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override bool Equals(object other) {
      return Equals(other as Position);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Equals(Position other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (X != other.X) return false;
      if (Y != other.Y) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override int GetHashCode() {
      int hash = 1;
      if (X != 0L) hash ^= X.GetHashCode();
      if (Y != 0L) hash ^= Y.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (X != 0L) {
        output.WriteRawTag(8);
        output.WriteInt64(X);
      }
      if (Y != 0L) {
        output.WriteRawTag(16);
        output.WriteInt64(Y);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (X != 0L) {
        output.WriteRawTag(8);
        output.WriteInt64(X);
      }
      if (Y != 0L) {
        output.WriteRawTag(16);
        output.WriteInt64(Y);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public int CalculateSize() {
      int size = 0;
      if (X != 0L) {
        size += 1 + pb::CodedOutputStream.ComputeInt64Size(X);
      }
      if (Y != 0L) {
        size += 1 + pb::CodedOutputStream.ComputeInt64Size(Y);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(Position other) {
      if (other == null) {
        return;
      }
      if (other.X != 0L) {
        X = other.X;
      }
      if (other.Y != 0L) {
        Y = other.Y;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 8: {
            X = input.ReadInt64();
            break;
          }
          case 16: {
            Y = input.ReadInt64();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 8: {
            X = input.ReadInt64();
            break;
          }
          case 16: {
            Y = input.ReadInt64();
            break;
          }
        }
      }
    }
    #endif

  }

  public sealed partial class Depot : pb::IMessage<Depot>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<Depot> _parser = new pb::MessageParser<Depot>(() => new Depot());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pb::MessageParser<Depot> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Settlement.SettlementReflection.Descriptor.MessageTypes[3]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Depot() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Depot(Depot other) : this() {
      store_ = other.store_.Clone();
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Depot Clone() {
      return new Depot(this);
    }

    /// <summary>Field number for the "Store" field.</summary>
    public const int StoreFieldNumber = 1;
    private static readonly pb::FieldCodec<global::Settlement.ResourceStorage> _repeated_store_codec
        = pb::FieldCodec.ForMessage(10, global::Settlement.ResourceStorage.Parser);
    private readonly pbc::RepeatedField<global::Settlement.ResourceStorage> store_ = new pbc::RepeatedField<global::Settlement.ResourceStorage>();
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public pbc::RepeatedField<global::Settlement.ResourceStorage> Store {
      get { return store_; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override bool Equals(object other) {
      return Equals(other as Depot);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Equals(Depot other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if(!store_.Equals(other.store_)) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override int GetHashCode() {
      int hash = 1;
      hash ^= store_.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      store_.WriteTo(output, _repeated_store_codec);
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      store_.WriteTo(ref output, _repeated_store_codec);
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public int CalculateSize() {
      int size = 0;
      size += store_.CalculateSize(_repeated_store_codec);
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(Depot other) {
      if (other == null) {
        return;
      }
      store_.Add(other.store_);
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            store_.AddEntriesFrom(input, _repeated_store_codec);
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            store_.AddEntriesFrom(ref input, _repeated_store_codec);
            break;
          }
        }
      }
    }
    #endif

  }

  public sealed partial class ResourceStorage : pb::IMessage<ResourceStorage>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<ResourceStorage> _parser = new pb::MessageParser<ResourceStorage>(() => new ResourceStorage());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pb::MessageParser<ResourceStorage> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Settlement.SettlementReflection.Descriptor.MessageTypes[4]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public ResourceStorage() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public ResourceStorage(ResourceStorage other) : this() {
      capacity_ = other.capacity_;
      currentStored_ = other.currentStored_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public ResourceStorage Clone() {
      return new ResourceStorage(this);
    }

    /// <summary>Field number for the "capacity" field.</summary>
    public const int CapacityFieldNumber = 1;
    private long capacity_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public long Capacity {
      get { return capacity_; }
      set {
        capacity_ = value;
      }
    }

    /// <summary>Field number for the "currentStored" field.</summary>
    public const int CurrentStoredFieldNumber = 2;
    private long currentStored_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public long CurrentStored {
      get { return currentStored_; }
      set {
        currentStored_ = value;
      }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override bool Equals(object other) {
      return Equals(other as ResourceStorage);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Equals(ResourceStorage other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (Capacity != other.Capacity) return false;
      if (CurrentStored != other.CurrentStored) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override int GetHashCode() {
      int hash = 1;
      if (Capacity != 0L) hash ^= Capacity.GetHashCode();
      if (CurrentStored != 0L) hash ^= CurrentStored.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (Capacity != 0L) {
        output.WriteRawTag(8);
        output.WriteInt64(Capacity);
      }
      if (CurrentStored != 0L) {
        output.WriteRawTag(16);
        output.WriteInt64(CurrentStored);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (Capacity != 0L) {
        output.WriteRawTag(8);
        output.WriteInt64(Capacity);
      }
      if (CurrentStored != 0L) {
        output.WriteRawTag(16);
        output.WriteInt64(CurrentStored);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public int CalculateSize() {
      int size = 0;
      if (Capacity != 0L) {
        size += 1 + pb::CodedOutputStream.ComputeInt64Size(Capacity);
      }
      if (CurrentStored != 0L) {
        size += 1 + pb::CodedOutputStream.ComputeInt64Size(CurrentStored);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(ResourceStorage other) {
      if (other == null) {
        return;
      }
      if (other.Capacity != 0L) {
        Capacity = other.Capacity;
      }
      if (other.CurrentStored != 0L) {
        CurrentStored = other.CurrentStored;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 8: {
            Capacity = input.ReadInt64();
            break;
          }
          case 16: {
            CurrentStored = input.ReadInt64();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 8: {
            Capacity = input.ReadInt64();
            break;
          }
          case 16: {
            CurrentStored = input.ReadInt64();
            break;
          }
        }
      }
    }
    #endif

  }

  public sealed partial class SettlementList : pb::IMessage<SettlementList>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<SettlementList> _parser = new pb::MessageParser<SettlementList>(() => new SettlementList());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pb::MessageParser<SettlementList> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Settlement.SettlementReflection.Descriptor.MessageTypes[5]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public SettlementList() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public SettlementList(SettlementList other) : this() {
      settlements_ = other.settlements_.Clone();
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public SettlementList Clone() {
      return new SettlementList(this);
    }

    /// <summary>Field number for the "settlements" field.</summary>
    public const int SettlementsFieldNumber = 1;
    private static readonly pb::FieldCodec<global::Settlement.Settlement> _repeated_settlements_codec
        = pb::FieldCodec.ForMessage(10, global::Settlement.Settlement.Parser);
    private readonly pbc::RepeatedField<global::Settlement.Settlement> settlements_ = new pbc::RepeatedField<global::Settlement.Settlement>();
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public pbc::RepeatedField<global::Settlement.Settlement> Settlements {
      get { return settlements_; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override bool Equals(object other) {
      return Equals(other as SettlementList);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Equals(SettlementList other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if(!settlements_.Equals(other.settlements_)) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override int GetHashCode() {
      int hash = 1;
      hash ^= settlements_.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      settlements_.WriteTo(output, _repeated_settlements_codec);
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      settlements_.WriteTo(ref output, _repeated_settlements_codec);
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public int CalculateSize() {
      int size = 0;
      size += settlements_.CalculateSize(_repeated_settlements_codec);
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(SettlementList other) {
      if (other == null) {
        return;
      }
      settlements_.Add(other.settlements_);
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            settlements_.AddEntriesFrom(input, _repeated_settlements_codec);
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            settlements_.AddEntriesFrom(ref input, _repeated_settlements_codec);
            break;
          }
        }
      }
    }
    #endif

  }

  public sealed partial class Building : pb::IMessage<Building>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<Building> _parser = new pb::MessageParser<Building>(() => new Building());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pb::MessageParser<Building> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Settlement.SettlementReflection.Descriptor.MessageTypes[6]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Building() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Building(Building other) : this() {
      id_ = other.id_;
      buildDef_ = other.buildDef_;
      inConstruction_ = other.inConstruction_;
      hibernated_ = other.hibernated_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Building Clone() {
      return new Building(this);
    }

    /// <summary>Field number for the "id" field.</summary>
    public const int IdFieldNumber = 1;
    private long id_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public long Id {
      get { return id_; }
      set {
        id_ = value;
      }
    }

    /// <summary>Field number for the "buildDef" field.</summary>
    public const int BuildDefFieldNumber = 3;
    private string buildDef_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public string BuildDef {
      get { return buildDef_; }
      set {
        buildDef_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "inConstruction" field.</summary>
    public const int InConstructionFieldNumber = 4;
    private bool inConstruction_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool InConstruction {
      get { return inConstruction_; }
      set {
        inConstruction_ = value;
      }
    }

    /// <summary>Field number for the "hibernated" field.</summary>
    public const int HibernatedFieldNumber = 5;
    private bool hibernated_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Hibernated {
      get { return hibernated_; }
      set {
        hibernated_ = value;
      }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override bool Equals(object other) {
      return Equals(other as Building);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Equals(Building other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (Id != other.Id) return false;
      if (BuildDef != other.BuildDef) return false;
      if (InConstruction != other.InConstruction) return false;
      if (Hibernated != other.Hibernated) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override int GetHashCode() {
      int hash = 1;
      if (Id != 0L) hash ^= Id.GetHashCode();
      if (BuildDef.Length != 0) hash ^= BuildDef.GetHashCode();
      if (InConstruction != false) hash ^= InConstruction.GetHashCode();
      if (Hibernated != false) hash ^= Hibernated.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (Id != 0L) {
        output.WriteRawTag(8);
        output.WriteInt64(Id);
      }
      if (BuildDef.Length != 0) {
        output.WriteRawTag(26);
        output.WriteString(BuildDef);
      }
      if (InConstruction != false) {
        output.WriteRawTag(32);
        output.WriteBool(InConstruction);
      }
      if (Hibernated != false) {
        output.WriteRawTag(40);
        output.WriteBool(Hibernated);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (Id != 0L) {
        output.WriteRawTag(8);
        output.WriteInt64(Id);
      }
      if (BuildDef.Length != 0) {
        output.WriteRawTag(26);
        output.WriteString(BuildDef);
      }
      if (InConstruction != false) {
        output.WriteRawTag(32);
        output.WriteBool(InConstruction);
      }
      if (Hibernated != false) {
        output.WriteRawTag(40);
        output.WriteBool(Hibernated);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public int CalculateSize() {
      int size = 0;
      if (Id != 0L) {
        size += 1 + pb::CodedOutputStream.ComputeInt64Size(Id);
      }
      if (BuildDef.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(BuildDef);
      }
      if (InConstruction != false) {
        size += 1 + 1;
      }
      if (Hibernated != false) {
        size += 1 + 1;
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(Building other) {
      if (other == null) {
        return;
      }
      if (other.Id != 0L) {
        Id = other.Id;
      }
      if (other.BuildDef.Length != 0) {
        BuildDef = other.BuildDef;
      }
      if (other.InConstruction != false) {
        InConstruction = other.InConstruction;
      }
      if (other.Hibernated != false) {
        Hibernated = other.Hibernated;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 8: {
            Id = input.ReadInt64();
            break;
          }
          case 26: {
            BuildDef = input.ReadString();
            break;
          }
          case 32: {
            InConstruction = input.ReadBool();
            break;
          }
          case 40: {
            Hibernated = input.ReadBool();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 8: {
            Id = input.ReadInt64();
            break;
          }
          case 26: {
            BuildDef = input.ReadString();
            break;
          }
          case 32: {
            InConstruction = input.ReadBool();
            break;
          }
          case 40: {
            Hibernated = input.ReadBool();
            break;
          }
        }
      }
    }
    #endif

  }

  public sealed partial class BuildBuildingCall : pb::IMessage<BuildBuildingCall>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<BuildBuildingCall> _parser = new pb::MessageParser<BuildBuildingCall>(() => new BuildBuildingCall());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pb::MessageParser<BuildBuildingCall> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Settlement.SettlementReflection.Descriptor.MessageTypes[7]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public BuildBuildingCall() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public BuildBuildingCall(BuildBuildingCall other) : this() {
      settlementId_ = other.settlementId_ != null ? other.settlementId_.Clone() : null;
      buildDef_ = other.buildDef_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public BuildBuildingCall Clone() {
      return new BuildBuildingCall(this);
    }

    /// <summary>Field number for the "settlementId" field.</summary>
    public const int SettlementIdFieldNumber = 1;
    private global::Common.SettlementId settlementId_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Common.SettlementId SettlementId {
      get { return settlementId_; }
      set {
        settlementId_ = value;
      }
    }

    /// <summary>Field number for the "buildDef" field.</summary>
    public const int BuildDefFieldNumber = 2;
    private string buildDef_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public string BuildDef {
      get { return buildDef_; }
      set {
        buildDef_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override bool Equals(object other) {
      return Equals(other as BuildBuildingCall);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Equals(BuildBuildingCall other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (!object.Equals(SettlementId, other.SettlementId)) return false;
      if (BuildDef != other.BuildDef) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override int GetHashCode() {
      int hash = 1;
      if (settlementId_ != null) hash ^= SettlementId.GetHashCode();
      if (BuildDef.Length != 0) hash ^= BuildDef.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (settlementId_ != null) {
        output.WriteRawTag(10);
        output.WriteMessage(SettlementId);
      }
      if (BuildDef.Length != 0) {
        output.WriteRawTag(18);
        output.WriteString(BuildDef);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (settlementId_ != null) {
        output.WriteRawTag(10);
        output.WriteMessage(SettlementId);
      }
      if (BuildDef.Length != 0) {
        output.WriteRawTag(18);
        output.WriteString(BuildDef);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public int CalculateSize() {
      int size = 0;
      if (settlementId_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(SettlementId);
      }
      if (BuildDef.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(BuildDef);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(BuildBuildingCall other) {
      if (other == null) {
        return;
      }
      if (other.settlementId_ != null) {
        if (settlementId_ == null) {
          SettlementId = new global::Common.SettlementId();
        }
        SettlementId.MergeFrom(other.SettlementId);
      }
      if (other.BuildDef.Length != 0) {
        BuildDef = other.BuildDef;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            if (settlementId_ == null) {
              SettlementId = new global::Common.SettlementId();
            }
            input.ReadMessage(SettlementId);
            break;
          }
          case 18: {
            BuildDef = input.ReadString();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            if (settlementId_ == null) {
              SettlementId = new global::Common.SettlementId();
            }
            input.ReadMessage(SettlementId);
            break;
          }
          case 18: {
            BuildDef = input.ReadString();
            break;
          }
        }
      }
    }
    #endif

  }

  public sealed partial class UpgradeBuildingCall : pb::IMessage<UpgradeBuildingCall>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<UpgradeBuildingCall> _parser = new pb::MessageParser<UpgradeBuildingCall>(() => new UpgradeBuildingCall());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pb::MessageParser<UpgradeBuildingCall> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Settlement.SettlementReflection.Descriptor.MessageTypes[8]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public UpgradeBuildingCall() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public UpgradeBuildingCall(UpgradeBuildingCall other) : this() {
      settlementId_ = other.settlementId_ != null ? other.settlementId_.Clone() : null;
      buildingId_ = other.buildingId_ != null ? other.buildingId_.Clone() : null;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public UpgradeBuildingCall Clone() {
      return new UpgradeBuildingCall(this);
    }

    /// <summary>Field number for the "settlementId" field.</summary>
    public const int SettlementIdFieldNumber = 1;
    private global::Common.SettlementId settlementId_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Common.SettlementId SettlementId {
      get { return settlementId_; }
      set {
        settlementId_ = value;
      }
    }

    /// <summary>Field number for the "buildingId" field.</summary>
    public const int BuildingIdFieldNumber = 2;
    private global::Common.BuildingId buildingId_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Common.BuildingId BuildingId {
      get { return buildingId_; }
      set {
        buildingId_ = value;
      }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override bool Equals(object other) {
      return Equals(other as UpgradeBuildingCall);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Equals(UpgradeBuildingCall other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (!object.Equals(SettlementId, other.SettlementId)) return false;
      if (!object.Equals(BuildingId, other.BuildingId)) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override int GetHashCode() {
      int hash = 1;
      if (settlementId_ != null) hash ^= SettlementId.GetHashCode();
      if (buildingId_ != null) hash ^= BuildingId.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (settlementId_ != null) {
        output.WriteRawTag(10);
        output.WriteMessage(SettlementId);
      }
      if (buildingId_ != null) {
        output.WriteRawTag(18);
        output.WriteMessage(BuildingId);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (settlementId_ != null) {
        output.WriteRawTag(10);
        output.WriteMessage(SettlementId);
      }
      if (buildingId_ != null) {
        output.WriteRawTag(18);
        output.WriteMessage(BuildingId);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public int CalculateSize() {
      int size = 0;
      if (settlementId_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(SettlementId);
      }
      if (buildingId_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(BuildingId);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(UpgradeBuildingCall other) {
      if (other == null) {
        return;
      }
      if (other.settlementId_ != null) {
        if (settlementId_ == null) {
          SettlementId = new global::Common.SettlementId();
        }
        SettlementId.MergeFrom(other.SettlementId);
      }
      if (other.buildingId_ != null) {
        if (buildingId_ == null) {
          BuildingId = new global::Common.BuildingId();
        }
        BuildingId.MergeFrom(other.BuildingId);
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            if (settlementId_ == null) {
              SettlementId = new global::Common.SettlementId();
            }
            input.ReadMessage(SettlementId);
            break;
          }
          case 18: {
            if (buildingId_ == null) {
              BuildingId = new global::Common.BuildingId();
            }
            input.ReadMessage(BuildingId);
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            if (settlementId_ == null) {
              SettlementId = new global::Common.SettlementId();
            }
            input.ReadMessage(SettlementId);
            break;
          }
          case 18: {
            if (buildingId_ == null) {
              BuildingId = new global::Common.BuildingId();
            }
            input.ReadMessage(BuildingId);
            break;
          }
        }
      }
    }
    #endif

  }

  #endregion

}

#endregion Designer generated code
